import React, {Component} from "react";
import {connect} from "react-redux";
import {getContacts} from "../../store/actions";
import Contact from "../../components/Contact/Contact";
import Modal from "../../components/UI/Modal/Modal";
import FullContact from "../../components/FullContact/FullContact";


class Contacts extends Component {
    state = {
        selectContact: null
    }

    componentDidMount() {
        this.props.getContacts()
    }

    selectHandler = (value) => {
        this.setState({selectContact: value})
    }

    printContacts = () => {
        let contacts = this.props.contacts
        return Object.keys(contacts).map(contact => {
            return <Contact
                select={() => this.selectHandler(contact)}
                name={contacts[contact].name}
                photo={contacts[contact].photo}
                key={contact}/>
        })
    }

    render() {
        return (
            <>
                {this.props.contacts ? <div className='Contacts'>{this.printContacts()}</div> : null}
                {
                    this.state.selectContact ?
                        <Modal backdrop={true}>
                            <>
                              <FullContact
                              name={this.props.contacts[this.state.selectContact].name}
                              phone={this.props.contacts[this.state.selectContact].phone}
                              email={this.props.contacts[this.state.selectContact].email}
                              photo={this.props.contacts[this.state.selectContact].photo}
                              id={this.state.selectContact}
                              selectHandler={this.selectHandler}
                              />
                            </>
                        </Modal>
                        : null
                }
            </>
        );
    }
}

const mapStateToProps = state => {
    return {
        contacts: state.contacts
    }
};

const mapDispatchToProps = dispatch => {
    return {
        getContacts: () => dispatch(getContacts())
    }
};

export default connect(mapStateToProps, mapDispatchToProps)(Contacts);
